// code-analyzer creates graph from a C source code.
// Copyright © 2021 Volodymyr Patuta
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "cparse.h"
#include "matcom.h"
#include "vec.h"
#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[])
{
	(void)argc;
	(void)argv;
	graph_vec gv = vnew_graph();
	graph_mco gmc = mcgragh();
	// find_funcs("/home/user/files/dot_files/st/x.c", &gv, &gmc);
	find_funcs("test.c", &gv, &gmc);
	// findAndParse("/home/user/files/dot_files/st/", &gv, &gmc);
	// vprint_nodes(gv.node[8]);
	mcprint_edges(gmc, 8);
	vfind_cycles(&gv);
	mcdelete_graph(&gmc);
	vdot_graph(gv, true);
	vdelete_graph(&gv);
	return 0;
}
